import java.util.ArrayList;
import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * Created by IntelliJ IDEA.
 * User: e3r
 * Date: 31.okt.2007
 * Time: 19:57:07
 * To change this template use File | Settings | File Templates.
 */

//todo: rewrite to 3 double lists one for each option type.
public class Globals {

    private static Globals globals;
    private static final String intSymbol = "i";
    private static final String doubleSymbol = "d";
    private static final String stringSymbol = "s";
    private static final String boleeanSymbol = "b";
    private static final String commentSymbol = "%";
    private static final String errorMessage = "Error parsing configuration file";

    private ArrayList<String>[] options;

    public Globals(String fileName) throws IOException {
        globals = this;
        BufferedReader reader = new BufferedReader(new FileReader(fileName));
        options = new ArrayList[3];
        options[0] = new ArrayList<String>();
        options[1] = new ArrayList<String>();
        options[2] = new ArrayList<String>();
        String s, a, b;
        StringTokenizer st;

        s = reader.readLine();
        while (s != null) {
            if (!(s.trim().startsWith(commentSymbol) || s.trim().length() == 0)) {
                st = new StringTokenizer(s);
                if (st.countTokens() != 3) {
                    throw new IOException(errorMessage);
                }
                options[0].add(st.nextToken());
                a = st.nextToken();
                b = st.nextToken();
                if (a.equals(intSymbol)) {
                    try {
                        Integer.parseInt(b);
                    } catch (NumberFormatException e) {
                        throw new IOException(errorMessage);
                    }
                } else if (a.equals(doubleSymbol)) {
                    try {
                        Double.parseDouble(b);
                    } catch (NumberFormatException e) {
                        throw new IOException(errorMessage);
                    }
                } else if (a.equals(stringSymbol)) {
                    //no way to check correctness of string entries.
                } else if (a.equals(boleeanSymbol)) {
                    try {
                        Boolean.parseBoolean(b);
                    } catch (NumberFormatException e) {
                        throw new IOException(errorMessage);
                    }
                } else {
                    throw new IOException(errorMessage);
                }
                options[1].add(a);
                options[2].add(b);
            }
            s = reader.readLine();
        }

    }

    public static int getInt(String name) {
        int i;
        boolean found = false;
        for (i = 0; i < globals.options[0].size(); i++) {
            if (globals.options[0].get(i).equals(name)) {
                found = true;
                break;
            }
        }
        //todo: add sanitycheck get method matches type.
        if (found) {
            return Integer.parseInt(globals.options[2].get(i));
        } else {
            System.err.println("ERROR: Variable '" + name + "' of type Integer (" + intSymbol + ") not specified in Configuration File!");
            System.exit(-1);
            return 0;
        }

    }

    public static double getDouble(String name) {
        int i;
        boolean found = false;
        for (i = 0; i < globals.options[0].size(); i++) {
            if (globals.options[0].get(i).equals(name)) {
                found = true;
                break;
            }
        }
        //todo: add sanitycheck get method matches type.
        if (found) {
            return Double.parseDouble(globals.options[2].get(i));
        } else {
            System.err.println("ERROR: Variable '" + name + "' of type Double (" + doubleSymbol + ") not specified in Configuration File!");
            System.exit(-1);
            return 0;
        }

    }

    public static boolean getBoolean(String name) {
        int i;
        boolean found = false;
        for (i = 0; i < globals.options[0].size(); i++) {
            if (globals.options[0].get(i).equals(name)) {
                found = true;
                break;
            }
        }
        //todo: add sanitycheck get method matches type.
        if (found) {
            return Boolean.parseBoolean(globals.options[2].get(i));
        } else {
            System.err.println("ERROR: Variable '" + name + "' of type Double (" + doubleSymbol + ") not specified in Configuration File!");
            System.exit(-1);
            return false;
        }

    }

    public static String getString(String name) {
        int i;
        boolean found = false;
        for (i = 0; i < globals.options[0].size(); i++) {
            if (globals.options[0].get(i).equals(name)) {
                found = true;
                break;
            }
        }
        //todo: add sanitycheck get method matches type.
        if (found) {
            return globals.options[2].get(i);
        } else {
            System.err.println("ERROR: Variable '" + name + "' of type String (" + stringSymbol + ") not specified in Configuration File!");
            System.exit(-1);
            return null;
        }

    }
}
