import java.util.ArrayList;

/**
 * Created by IntelliJ IDEA.
 * User: e3r
 * Date: 05.nov.2007
 * Time: 15:02:16
 * To change this template use File | Settings | File Templates.
 */
public class LC {

    private class Cluster {

        Cluster(TimeSeries c, int size) {
            center = c;
            members = new TimeSeries[size];
        }

        TimeSeries center;
        TimeSeries[] members;
        double radius;
    }

    private static final int INITIAL_LIST_OF_CLUSTERS_SIZE = 50;    //todo: remove
    private static final int INITIAL_CANDIDATE_SET_SIZE = 30;   //todo: remove

    private static final String FINAL_BUCKET_SIZE_CONFIG_STRING = "LC-FinalBucketSize"; //todo: remove
    private static final String NUMBER_OF_ELEMENTS_PER_CLUSTER_CONFIG_STRING = "LC-ElementsPerCluster";

    private DataSet dataSet;
    private DistanceMeasure distanceMeasure;
    ArrayList<Cluster> listOfClusters;
    TimeSeries[] lastBucket;

    private int distanceCalculationCounter;

    public void construct(DataSet ds, DistanceMeasure dm) {
        dataSet = ds;
        distanceMeasure = dm;
        distanceCalculationCounter = 0;
        int finalBucketSize = Globals.getInt(FINAL_BUCKET_SIZE_CONFIG_STRING);  //todo: remove i guess
        ArrayList<TimeSeries> pool = new ArrayList<TimeSeries>(dataSet.size());
        for (int i = 0; i < dataSet.size(); i++) {
            pool.add(dataSet.get(i));
        }
        int numOfEle = Globals.getInt(NUMBER_OF_ELEMENTS_PER_CLUSTER_CONFIG_STRING);
        listOfClusters = new ArrayList<Cluster>((dataSet.size() / numOfEle) + 1);

        TimeSeries center = pool.get((int) (Math.random() * pool.size()));

        while (pool.size() > numOfEle) {

            //calculate distances form center to all elements in pool
            double[] distances = new double[pool.size()];
            for (int i = 0; i < distances.length; i++) {
                distances[i] = distanceMeasure.calculateDistance(center, pool.get(i));
            }

            //variables for candidate set tracking
            int[] candidats = new int[numOfEle];
            int maxIndex = -1;
            double maxValue = -1;

            //variables for next center tracking
            double newCValue = -1;
            int newCIndex = -1;

            //fill up the candidate set with the first elements in the pool
            for (int i = 0; i < numOfEle; i++) {
                candidats[i] = i;
                //determine the biggest distance in the candidate set
                if (maxValue < distances[i]) {
                    maxValue = distances[i];
                    maxIndex = i;
                }
                //determine the biggest distance in the pool for next center , part 1
                if (newCValue < distances[i]) {
                    newCValue = distances[i];
                    newCIndex = i;
                }
            }

            //process the rest of the elements in the pool
            for (int i = numOfEle; i < pool.size(); i++) {
                //check to see if new element shoud replace worst in candidate set
                if (distances[i] < maxValue) {
                    candidats[maxIndex] = i;
                    maxIndex = -1;
                    maxValue = -1;
                    //find new worst element in candidat set
                    for (int j = 0; j < candidats.length; j++) {
                        if (maxValue < distances[candidats[j]]) {
                            maxValue = distances[candidats[j]];
                            maxIndex = j;
                        }
                    }
                }
                //detemrine biggest distance in pool for next center, part 2
                if (newCValue < distances[i]) {
                    newCValue = distances[i];
                    newCIndex = i;
                }
            }

            //create new cluster and fill with candidates
            Cluster c = new Cluster(center, numOfEle);
            for (int i = 0; i < candidats.length; i++) {
                c.members[i] = pool.get(candidats[i]);
            }
            //set the radius of the cluster to the maximum distance value
            c.radius = maxValue;

            listOfClusters.add(c);

            //set new center
            center = pool.get(newCIndex);

            //remove used elements from pool
            for (int i = 0; i < candidats.length; i++) {
                pool.remove(c.members[i]);
            }
        }

        //put all the leftover elements in the finalBucket
        lastBucket = new TimeSeries[pool.size()];
        for (int i = 0; i < lastBucket.length; i++) {
            lastBucket[i] = pool.remove(0);
        }

    }

    public TimeSeries[] radiusQueryRough(TimeSeries query, double r) {
        double distance, min, max;
        Cluster cluster;
        int counter = 0;
        ArrayList<TimeSeries> candidats = new ArrayList<TimeSeries>(100);
        //fix for missing last bucket, silly stuffs, no center due to implementation, radious probably humongous
        for (TimeSeries t : lastBucket) {
            candidats.add(t);
        }
        for (int c = 0; c < listOfClusters.size(); c++) {
            cluster = listOfClusters.get(c);
            distance = distanceMeasure.calculateDistance(cluster.center, query);
            distanceCalculationCounter++;
            counter++;

            //enclosed
            if (distance + r < cluster.radius) {
                for (TimeSeries ts : cluster.members) {
                    candidats.add(ts);
                }
                break;
            }
            //overlap
            else if (distance < r + cluster.radius) {
                for (TimeSeries ts : cluster.members) {
                    candidats.add(ts);
                }
            }
            //no overlap
            else {
                //do nada
            }

        }

        TimeSeries[] result = new TimeSeries[candidats.size()];
        for (int i = 0; i < result.length; i++) {
            result[i] = candidats.get(i);
        }
        return result;
    }


    public void resetDistanceCalculationCounter() {
        distanceCalculationCounter = 0;
    }

    public int getDistanceCalculationCounter() {
        return distanceCalculationCounter;
    }

}
