import java.util.ArrayList;

/**
 * Created by IntelliJ IDEA.
 * User: e3r
 * Date: 05.nov.2007
 * Time: 13:39:43
 * To change this template use File | Settings | File Templates.
 */
public class PCA {

    private static final String NUMBER_OF_SEGMENTS_CONFIG_STRING = "PCA-NumberOfSegments";

    private DataSet dataSet;
    private DistanceMeasure distanceMeasure;
    private TimeSeries[] signatures;
    private int numberOfSegments;

    public void construct(DataSet d, DistanceMeasure dm) {
        //init vars
        dataSet = d;
        distanceMeasure = dm;
        numberOfSegments = Globals.getInt(NUMBER_OF_SEGMENTS_CONFIG_STRING);
        signatures = new TimeSeries[dataSet.size()];

        //main loop over all Time series
        for (int i = 0; i < signatures.length; i++) {

            //adds signature to signatures
            signatures[i] = new TimeSeries(createSiganture(dataSet.get(i)));
        }

    }

    private double[] createSiganture(TimeSeries t) {
        int segmentLength = dataSet.timeSeriesLengt() / numberOfSegments;
        double[] signature = new double[numberOfSegments];
        int seg = 0;
        double accu;
        //loop: handles all but the last segment, which might be of different length
        for (; seg < numberOfSegments - 1; seg++) {
            accu = 0;
            //fills up accumilator
            for (int x = 0; x < segmentLength; x++) {
                accu += t.get(x + (segmentLength * seg));
            }
            //does avrage calculation
            signature[seg] = accu / segmentLength;  //todo. wella, coorect?
        }

        accu = 0;
        int counter = 0;
        //loop for last segment, counter = its length, fills up accu
        for (int x = seg * segmentLength; x < t.size(); x++) {
            accu += t.get(x);
            counter++;
        }
        //last seg avrage calc
        signature[seg] = accu / counter; //todo: wella also correct?

        return signature;
    }

    public TimeSeries[] radiusQueryRough(TimeSeries query, double r) {
        TimeSeries qsig = new TimeSeries(createSiganture(query));
        ArrayList<Integer> candidates = new ArrayList<Integer>(100);
        for (int i = 0 ; i < signatures.length ; i++) {
            if (distanceMeasure.calculateDistance(qsig, signatures[i]) * Math.sqrt(dataSet.timeSeriesLengt()/numberOfSegments) < r) {   //todo: is teh otimal factor correts here?
                candidates.add(i);
            }
        }

        TimeSeries[] results = new TimeSeries[candidates.size()];
        for (int i = 0 ; i < results.length ; i++) {
            results[i] = dataSet.get(candidates.get(i));
        }
        return results;
    }

    public void resetDistanceCalculationCounter() {

    }

    public int getDistanceCalculationCounter() {
        return 0;
    }
}
