import java.io.IOException;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Random;

/**
 * Created by IntelliJ IDEA.
 * User: e3r
 * Date: 13.nov.2007
 * Time: 19:22:20
 * To change this template use File | Settings | File Templates.
 */
public class QueryMaker {

    public static void main(String[] args) {
        if (args.length < 4) {
            System.err.println("ERROR: not enough args");
            System.out.println("Input_file number_of_queries_to_make noise_std outputfile");
            System.out.println("ex: QueryMaker dataset1.txt 10 5.6 queryset1.txt");
            System.exit(-1);
        }
        // inputFile number noiseSTD outputFile
        DataSetProducer prod;
        DataSet input = null;
        try {
            prod = new DataSetProducer(args[0]);
            input = prod.produceDataSet();
        } catch (Exception e) {
            System.err.println("ERROR: Input file not found");
            System.exit(-1);
        }

        System.out.println("Dataset Avrage Absolute Value: "+input.getAvrageAbsDataValue());
        System.out.println("Dataset Timeseries Length: "+input.timeSeriesLengt());
        System.out.println("Dataset Size: "+ input.size());

        TimeSeries[] output = new TimeSeries[Integer.parseInt(args[1])];
        //todo: room for adding pick-uniqueness
        //pick some rand om timeseries
        for (int i = 0; i < output.length; i++) {
            output[i] = input.get((int) (Math.random() * input.size()));
        }

        //lets add some noise!
        double noiseFactor = Double.parseDouble(args[2]);
        Random rand = new Random();
        for (int s = 0; s < output.length; s++) {
            for (int e = 0; e < output[0].size(); e++) {
                output[s].set(e, output[s].get(e) + (rand.nextGaussian() * noiseFactor));
            }
        }

        //and output the data
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter(args[3]));
            for (TimeSeries t : output) {
                for (int i = 0 ; i < t.size() ; i++) {
                    bw.write(t.get(i)+" ");
                }
                bw.newLine();
            }
            bw.close();
        } catch (IOException e) {
            System.err.println("ERROR: Could not write to output file");
        }

        System.out.println("All Done!");
    }

}
